/**************************************************************************

api_compile.p -- We use this as our entry point for a complete propath
                 compile sequence.  It should be usable via CLI, CHUI,
                 GUI, and WWW interfaces in front of it.

$Id: api_compile.p,v 1.3 2007/05/18 03:06:41 sauge Exp $

$Log: api_compile.p,v $
Revision 1.3  2007/05/18 03:06:41  sauge
Added messages for a log file.

Revision 1.2  2007/05/18 02:19:49  sauge
WIP

Revision 1.1  2007/05/18 02:07:08  sauge
Initial revision

***************************************************************************/

/**************************************************************************/
/* We set our version control tag in a string so it flows into the r-code */
/**************************************************************************/

DEFINE VARIABLE RCS AS CHARACTER NO-UNDO.
ASSIGN RCS="$Id: api_compile.p,v 1.3 2007/05/18 03:06:41 sauge Exp $".

DEFINE INPUT PARAMETER cListing AS CHARACTER NO-UNDO.
DEFINE INPUT PARAMETER cXRef AS CHARACTER NO-UNDO.

{compile_list.i}

PUT UNFORMATTED "Compiling with PROPATH: " PROPATH SKIP.
PUT UNFORMATTED "Time: " STRING (TIME, "HH:MM:SS") SKIP.
PUT UNFORMATTED "Date: " TODAY SKIP.

/**************************************************************************/
/* First we go make a listing of files to be compiled by walking the      */
/* PROPATH.                                                               */
/**************************************************************************/

RUN walk_propath.p (OUTPUT TABLE FileList).

/**************************************************************************/
/* Once we have that, we slip through that listing compiling as we go.    */
/**************************************************************************/

FOR EACH FileList NO-LOCK:

  PUT UNFORMATTED "Compiling " FileList.FileName SKIP.

  RUN compile_file.p (INPUT FileList.FileName, INPUT cListing, INPUT cXRef).

END. /* FOR EACH FileList */


