/**************************************************************************

compile_file.p -- Given the file (with absolute path) with the flags, do
                  a compile of the file.

$Id: compile_file.p,v 1.4 2007/05/23 05:17:34 sauge Exp sauge $

$Log: compile_file.p,v $
Revision 1.4  2007/05/23 05:17:34  sauge
Added ability to do both listing and xref at the same time.

Revision 1.3  2007/05/18 04:01:00  sauge
Enabled for Webspeed E4GL files

Revision 1.2  2007/05/18 03:24:49  sauge
Working

Revision 1.1  2007/05/18 02:24:24  sauge
Initial revision


***************************************************************************/

/**************************************************************************/
/* We set our version control tag in a string so it flows into the r-code */
/**************************************************************************/

DEFINE VARIABLE RCS AS CHARACTER NO-UNDO.
ASSIGN RCS="$Id: compile_file.p,v 1.4 2007/05/23 05:17:34 sauge Exp sauge $".

{postfix.i}
{basename.i}

DEFINE INPUT PARAMETER cFileName AS CHARACTER NO-UNDO.
DEFINE INPUT PARAMETER cListing  AS CHARACTER NO-UNDO.
DEFINE INPUT PARAMETER cXRef     AS CHARACTER NO-UNDO.

DEFINE VARIABLE cTempFile        AS CHARACTER NO-UNDO.
DEFINE VARIABLE cObjectType      AS CHARACTER NO-UNDO.
DEFINE VARIABLE cOrgFileName     AS CHARACTER NO-UNDO.
DEFINE VARIABLE lHTMLConversion  AS LOGICAL NO-UNDO.

/**************************************************************************/
/* This is needed by webutil/e4gl-gen.p                                   */
/**************************************************************************/

DEFINE NEW SHARED STREAM WebStream.

/**************************************************************************/
/* If we are dealing with an htm or html file, we need to convert it 1st  */
/**************************************************************************/

ASSIGN cTempFile = "".  /* Important later on */
ASSIGN lHTMLConversion = NO.

IF PostFix(cFileName) = ".html" OR PostFix(cFileName) = ".htm" THEN DO:

  ASSIGN lHTMLConversion = YES.

  PUT UNFORMATTED "Converting HTML into .p for " cFileName SKIP.

  /*************************************************************************/
  /* Names are weird because we started out with cFileName in non-webspeed */
  /* version                                                               */
  /*************************************************************************/

  ASSIGN cOrgFileName = cFileName.
  ASSIGN cTempFile = BaseName (cFileName) + ".p".

  RUN webutil/e4gl-gen.p (INPUT cFileName, INPUT-OUTPUT cObjectType, INPUT-OUTPUT cTempFile).

  ASSIGN cFileName = cTempFile.
  PUT UNFORMATTED "Object Type: " cObjectType SKIP.
  PUT UNFORMATTED "Stored .p in " cFileName SKIP.

END.

/**************************************************************************/
/* This would be nice combined but is easier to grasp with seperate       */
/* compile statements.                                                    */
/**************************************************************************/

IF cListing = "yes" THEN
  COMPILE VALUE(cFileName) LISTING VALUE(cFileName + ".listing") SAVE.

IF cXref = "yes" THEN
  COMPILE VALUE(cFileName) XREF VALUE(cFileName + ".xref") SAVE.

COMPILE VALUE(cFileName) SAVE.

/**************************************************************************/
/* If cTempFile is populated, we know we used E4GL on a temp name.  Must  */
/* rename the r-code to the orginal basename of the cTempFile.            */
/**************************************************************************/

IF cTempFile <> "" THEN DO:

/*
  PUT UNFORMATTED "Moving " BaseName(cFileName) + ".r" " to " BaseName(cOrgFilename) + ".r" SKIP.
  RUN osmove.p (INPUT BaseName(cFileName) + ".r", INPUT BaseName(cOrgFilename) + ".r").

  IF cXref = "YES" THEN DO:

    PUT UNFORMATTED "Moving " BaseName(cFileName) + ".xref" " to " BaseName(cOrgFilename) + ".xref" SKIP.
    RUN osmove.p (INPUT BaseName(cFileName) + ".xref", INPUT BaseName(cOrgFilename) + ".xref").

  END. /* IF cXref */

  IF cListing = "YES" THEN DO:

    PUT UNFORMATTED "Moving " BaseName(cFileName) + ".listing" " to " BaseName(cOrgFilename) + ".listing" SKIP.
    RUN osmove.p (INPUT BaseName(cFileName) + ".listing", INPUT BaseName(cOrgFilename) + ".listing").

  END. /* IF cListing */
*/
  PUT UNFORMATTED "Removing File " cFileName SKIP.
  OS-DELETE VALUE(cFileName).


END.

